---
- name: create directory
  file: 
    path: "{{matrix_synapse_service_directory}}"
    state: directory

- name: create initdb.d directory
  file: 
    path: "{{matrix_synapse_service_directory}}/initdb.d"
    state: directory

- name: set synapse homeserver config
  copy:
    content: "{{ matrix_synapse_homeserver_config | to_nice_yaml(indent=2, width=777) }}"
    dest: "{{ matrix_synapse_service_directory }}/homeserver.yaml"

- name: template postgres env file
  template:
    src: postgres.env.j2
    dest: "{{ matrix_synapse_service_directory }}/postgres.env"  

- name: copy postgres init script
  copy:
    src: create-default-postgres-user.sh
    dest: "{{ matrix_synapse_service_directory }}/initdb.d/create-default-postgres-user.sh"

- name: template synapse env file
  template:
    src: synapse.env.j2
    dest: "{{ matrix_synapse_service_directory }}/synapse.env"  

- name: template service discovery nginx config
  template:
    src: service-discovery-nginx.conf.j2
    dest: "{{ matrix_synapse_service_directory }}/service-discovery-nginx.conf"
  tags:
    - matrix_service_discovery
    - matrix-service-discovery

- name: template docker-compose config
  template:
    src: docker-compose.yaml.j2
    dest: "{{ matrix_synapse_service_directory }}/docker-compose.yaml"

- name: set traefik dynamic config
  copy:
    content: "{{ matrix_synapse_traefik_dynamic_config | to_nice_yaml(indent=2, width=777) }}"
    dest: "/srv/traefik/conf.d/{{matrix_synapse_service_name}}.yaml"
  tags:
    - matrix_service_discovery
    - matrix-service-discovery

- name: deploy docker-compose stack
  docker_compose:
    project_src: "{{ matrix_synapse_service_directory }}"
    # This option ensures that the images are rebuilt
    # build: true
    pull: true
    remove_orphans: true
